<?php
#SQLiteѥǡ١饹
class db{

	var $db_link;
	var $result;
	var $transaction;
	var $row = array();
# 󥹥ȥ饯ǥǡ١³ޤ
	function db($host, $user, $password, $database) {
		$this->db_link = @sqlite_open("db/$database");
		$this->transaction = FALSE;
		return $this->db_link;
	}
# ǡ١closeޤ
	function close() {
		if ($this->db_link) return @sqlite_close($this->db_link);
	}
# $tableޤ
	function log_count($table) {
		$query = "SELECT count(*) FROM $table";
		$result = @sqlite_unbuffered_query($this->db_link, $query);
		$tmp = @sqlite_fetch_array($result, SQLITE_NUM);
		return $tmp[0];
	}
# Ǹinsertǡidޤ
	function last_id() {
		return @sqlite_last_insert_rowid($this->db_link);
	}

	function query($query) {
		$this->result = @sqlite_query($this->db_link, $query);
		return $this->result;
	}

	function fetch_num($result_id = 0) {
		if (!$result_id) $result_id = $this->result;
		$this->row[$result_id] = @sqlite_fetch_array($result_id, SQLITE_NUM);
		return $this->row[$result_id];
	}

	function fetch_assoc($result_id = 0) {
		if (!$result_id) $result_id = $this->result;
		$this->row[$result_id] = @sqlite_fetch_array($result_id, SQLITE_ASSOC);
		return $this->row[$result_id];
	}

	function single_num($query) {
		$result = @sqlite_query($this->db_link, $query);
		return @sqlite_fetch_array($result, SQLITE_NUM);
	}

	function single_assoc($query) {
		$result = @sqlite_query($this->db_link, $query);
		return @sqlite_fetch_array($result, SQLITE_ASSOC);
	}

	function rowset_num($query) {
		return @sqlite_array_query($this->db_link, $query, SQLITE_NUM);
	}

	function rowset_assoc($query) {
		return @sqlite_array_query($this->db_link, $query, SQLITE_ASSOC);
	}

	function rowset_num_limit($query,$offset,$rows) {
		return @sqlite_array_query($this->db_link, "$query LIMIT $rows OFFSET $offset", SQLITE_NUM);
	}

	function rowset_assoc_limit($query,$offset,$rows) {
		return @sqlite_array_query($this->db_link, "$query LIMIT $rows OFFSET $offset", SQLITE_ASSOC);
	}

	function error($msg) {
		$error_code = sqlite_last_error($this->db_link);
		if ($error_code) echo "Error No.".$error_code."".sqlite_error_string($error_code)."<br>\n<font color=red>".$msg."</font><br>\n";
		if ($this->transaction) {
			@sqlite_query($this->db_link, "ROLLBACK");
			$this->transaction = FALSE;
		}
	}

	function escape_string($str) {
		return @sqlite_escape_string($str);
	}
	function begin_transaction() {
		if (!$this->transaction) {
			$this->transaction = TRUE;
			return @sqlite_query($this->db_link, "BEGIN");
		}
	}
	function commit_transaction() {
		if ($this->transaction) {
			$this->transaction = FALSE;
			return @sqlite_query($this->db_link, "COMMIT");
		}
	}
	function remake($table) {
		$query = "DROP TABLE $table";
		$result = @sqlite_query($this->db_link, $query);
		if ($result) {
			$query="CREATE TABLE $table (
			id INTEGER PRIMARY KEY,
			title,
			url,
			mark,
			last_time,
			passwd,
			message,
			comment,
			name,
			mail,
			category,
			stamp,
			banner,
			renew,
			ip,
			keywd
			)";
			$result = @sqlite_query($this->db_link, $query);
		}
		return $result;
	}
	function list_tables($database="") {
		$query = "SELECT name FROM sqlite_master WHERE type='table'";
		$table = @sqlite_array_query($this->db_link, $query, SQLITE_ASSOC);
		foreach ($table as $name) {
			$tb_names[] = $name[name];
		}
		return $tb_names;
	}
}
?>
